<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestRouteTracker xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../testapidocs/org/apache/http/conn/routing/TestRouteTracker.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.conn.routing;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.net.InetAddress;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.util.HashSet;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.util.Set;
<a class="jxr_linenumber" name="33" href="#33">33</a>  
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpHost;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.RouteInfo.TunnelType;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.RouteInfo.LayerType;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.junit.Assert;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="39" href="#39">39</a>  
<a class="jxr_linenumber" name="40" href="#40">40</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="41" href="#41">41</a>  <em class="jxr_javadoccomment"> * Tests for {@link RouteTracker}.</em>
<a class="jxr_linenumber" name="42" href="#42">42</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/conn/routing/TestRouteTracker.html">TestRouteTracker</a> {
<a class="jxr_linenumber" name="44" href="#44">44</a>  
<a class="jxr_linenumber" name="45" href="#45">45</a>      <em class="jxr_comment">// a selection of constants for generating routes</em>
<a class="jxr_linenumber" name="46" href="#46">46</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="47" href="#47">47</a>          HttpHost TARGET1 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"target1.test.invalid"</span>);
<a class="jxr_linenumber" name="48" href="#48">48</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="49" href="#49">49</a>          HttpHost TARGET2 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"target2.test.invalid"</span>, 8080);
<a class="jxr_linenumber" name="50" href="#50">50</a>      <em class="jxr_comment">// It is not necessary to have extra targets for https.</em>
<a class="jxr_linenumber" name="51" href="#51">51</a>      <em class="jxr_comment">// The 'layered' and 'secure' flags are specified explicitly</em>
<a class="jxr_linenumber" name="52" href="#52">52</a>      <em class="jxr_comment">// for routes, they will not be determined from the scheme.</em>
<a class="jxr_linenumber" name="53" href="#53">53</a>  
<a class="jxr_linenumber" name="54" href="#54">54</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="55" href="#55">55</a>          HttpHost PROXY1 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"proxy1.test.invalid"</span>);
<a class="jxr_linenumber" name="56" href="#56">56</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="57" href="#57">57</a>          HttpHost PROXY2 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"proxy2.test.invalid"</span>, 1080);
<a class="jxr_linenumber" name="58" href="#58">58</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="59" href="#59">59</a>          HttpHost PROXY3 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"proxy3.test.invalid"</span>, 88);
<a class="jxr_linenumber" name="60" href="#60">60</a>  
<a class="jxr_linenumber" name="61" href="#61">61</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> InetAddress LOCAL41;
<a class="jxr_linenumber" name="62" href="#62">62</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> InetAddress LOCAL42;
<a class="jxr_linenumber" name="63" href="#63">63</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> InetAddress LOCAL61;
<a class="jxr_linenumber" name="64" href="#64">64</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> InetAddress LOCAL62;
<a class="jxr_linenumber" name="65" href="#65">65</a>  
<a class="jxr_linenumber" name="66" href="#66">66</a>      <em class="jxr_comment">// need static initializer to deal with exceptions</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>      <strong class="jxr_keyword">static</strong> {
<a class="jxr_linenumber" name="68" href="#68">68</a>          <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="69" href="#69">69</a>              LOCAL41 = InetAddress.getByAddress(<strong class="jxr_keyword">new</strong> byte[]{ 127, 0, 0, 1 });
<a class="jxr_linenumber" name="70" href="#70">70</a>              LOCAL42 = InetAddress.getByAddress(<strong class="jxr_keyword">new</strong> byte[]{ 127, 0, 0, 2 });
<a class="jxr_linenumber" name="71" href="#71">71</a>  
<a class="jxr_linenumber" name="72" href="#72">72</a>              LOCAL61 = InetAddress.getByAddress(<strong class="jxr_keyword">new</strong> byte[]{
<a class="jxr_linenumber" name="73" href="#73">73</a>                  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
<a class="jxr_linenumber" name="74" href="#74">74</a>              });
<a class="jxr_linenumber" name="75" href="#75">75</a>              LOCAL62 = InetAddress.getByAddress(<strong class="jxr_keyword">new</strong> byte[]{
<a class="jxr_linenumber" name="76" href="#76">76</a>                  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2
<a class="jxr_linenumber" name="77" href="#77">77</a>              });
<a class="jxr_linenumber" name="78" href="#78">78</a>  
<a class="jxr_linenumber" name="79" href="#79">79</a>          } <strong class="jxr_keyword">catch</strong> (Exception x) {
<a class="jxr_linenumber" name="80" href="#80">80</a>              <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> ExceptionInInitializerError(x);
<a class="jxr_linenumber" name="81" href="#81">81</a>          }
<a class="jxr_linenumber" name="82" href="#82">82</a>      }
<a class="jxr_linenumber" name="83" href="#83">83</a>  
<a class="jxr_linenumber" name="84" href="#84">84</a>      @Test
<a class="jxr_linenumber" name="85" href="#85">85</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCstrTargetLocal() {
<a class="jxr_linenumber" name="86" href="#86">86</a>  
<a class="jxr_linenumber" name="87" href="#87">87</a>          RouteTracker rt = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="88" href="#88">88</a>          Assert.assertEquals(<span class="jxr_string">"wrong target (target,null)"</span>,
<a class="jxr_linenumber" name="89" href="#89">89</a>                       TARGET1, rt.getTargetHost());
<a class="jxr_linenumber" name="90" href="#90">90</a>          Assert.assertEquals(<span class="jxr_string">"wrong local address (target,null)"</span>,
<a class="jxr_linenumber" name="91" href="#91">91</a>                       <strong class="jxr_keyword">null</strong>, rt.getLocalAddress());
<a class="jxr_linenumber" name="92" href="#92">92</a>          Assert.assertEquals(<span class="jxr_string">"wrong hop count (target,null)"</span>,
<a class="jxr_linenumber" name="93" href="#93">93</a>                       0, rt.getHopCount());
<a class="jxr_linenumber" name="94" href="#94">94</a>          Assert.assertEquals(<span class="jxr_string">"wrong proxy (target,null)"</span>,
<a class="jxr_linenumber" name="95" href="#95">95</a>                       <strong class="jxr_keyword">null</strong>, rt.getProxyHost());
<a class="jxr_linenumber" name="96" href="#96">96</a>          Assert.assertEquals(<span class="jxr_string">"wrong route (target,null)"</span>,
<a class="jxr_linenumber" name="97" href="#97">97</a>                       <strong class="jxr_keyword">null</strong>, rt.toRoute());
<a class="jxr_linenumber" name="98" href="#98">98</a>          checkCTLS(rt, false, false, false, false);
<a class="jxr_linenumber" name="99" href="#99">99</a>  
<a class="jxr_linenumber" name="100" href="#100">100</a> 
<a class="jxr_linenumber" name="101" href="#101">101</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET2, LOCAL61);
<a class="jxr_linenumber" name="102" href="#102">102</a>         Assert.assertEquals(<span class="jxr_string">"wrong target (target,local)"</span>,
<a class="jxr_linenumber" name="103" href="#103">103</a>                      TARGET2, rt.getTargetHost());
<a class="jxr_linenumber" name="104" href="#104">104</a>         Assert.assertEquals(<span class="jxr_string">"wrong local address (target,local)"</span>,
<a class="jxr_linenumber" name="105" href="#105">105</a>                      LOCAL61, rt.getLocalAddress());
<a class="jxr_linenumber" name="106" href="#106">106</a>         Assert.assertEquals(<span class="jxr_string">"wrong hop count (target,local)"</span>,
<a class="jxr_linenumber" name="107" href="#107">107</a>                      0, rt.getHopCount());
<a class="jxr_linenumber" name="108" href="#108">108</a>         Assert.assertEquals(<span class="jxr_string">"wrong proxy (target,local)"</span>,
<a class="jxr_linenumber" name="109" href="#109">109</a>                      <strong class="jxr_keyword">null</strong>, rt.getProxyHost());
<a class="jxr_linenumber" name="110" href="#110">110</a>         Assert.assertEquals(<span class="jxr_string">"wrong route (target,local)"</span>,
<a class="jxr_linenumber" name="111" href="#111">111</a>                      <strong class="jxr_keyword">null</strong>, rt.toRoute());
<a class="jxr_linenumber" name="112" href="#112">112</a>         checkCTLS(rt, false, false, false, false);
<a class="jxr_linenumber" name="113" href="#113">113</a> 
<a class="jxr_linenumber" name="114" href="#114">114</a> 
<a class="jxr_linenumber" name="115" href="#115">115</a>         rt = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="116" href="#116">116</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="117" href="#117">117</a>             <strong class="jxr_keyword">new</strong> RouteTracker(<strong class="jxr_keyword">null</strong>, LOCAL41);
<a class="jxr_linenumber" name="118" href="#118">118</a>             Assert.fail(<span class="jxr_string">"null target not detected"</span>);
<a class="jxr_linenumber" name="119" href="#119">119</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="120" href="#120">120</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="121" href="#121">121</a>         }
<a class="jxr_linenumber" name="122" href="#122">122</a>     }
<a class="jxr_linenumber" name="123" href="#123">123</a> 
<a class="jxr_linenumber" name="124" href="#124">124</a>     @Test
<a class="jxr_linenumber" name="125" href="#125">125</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCstrRoute() {
<a class="jxr_linenumber" name="126" href="#126">126</a> 
<a class="jxr_linenumber" name="127" href="#127">127</a>         HttpRoute    r  = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1);
<a class="jxr_linenumber" name="128" href="#128">128</a>         RouteTracker rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="129" href="#129">129</a>         Assert.assertEquals(<span class="jxr_string">"wrong target (r1)"</span>,
<a class="jxr_linenumber" name="130" href="#130">130</a>                      TARGET1, rt.getTargetHost());
<a class="jxr_linenumber" name="131" href="#131">131</a>         Assert.assertEquals(<span class="jxr_string">"wrong local address (r1)"</span>,
<a class="jxr_linenumber" name="132" href="#132">132</a>                      <strong class="jxr_keyword">null</strong>, rt.getLocalAddress());
<a class="jxr_linenumber" name="133" href="#133">133</a>         Assert.assertEquals(<span class="jxr_string">"wrong hop count (r1)"</span>,
<a class="jxr_linenumber" name="134" href="#134">134</a>                      0, rt.getHopCount());
<a class="jxr_linenumber" name="135" href="#135">135</a>         Assert.assertEquals(<span class="jxr_string">"wrong proxy (r1)"</span>,
<a class="jxr_linenumber" name="136" href="#136">136</a>                      <strong class="jxr_keyword">null</strong>, rt.getProxyHost());
<a class="jxr_linenumber" name="137" href="#137">137</a>         Assert.assertEquals(<span class="jxr_string">"wrong route (r1)"</span>,
<a class="jxr_linenumber" name="138" href="#138">138</a>                      <strong class="jxr_keyword">null</strong>, rt.toRoute());
<a class="jxr_linenumber" name="139" href="#139">139</a>         checkCTLS(rt, false, false, false, false);
<a class="jxr_linenumber" name="140" href="#140">140</a> 
<a class="jxr_linenumber" name="141" href="#141">141</a>         r  = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, LOCAL61, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="142" href="#142">142</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="143" href="#143">143</a>         Assert.assertEquals(<span class="jxr_string">"wrong target (r2)"</span>,
<a class="jxr_linenumber" name="144" href="#144">144</a>                      TARGET2, rt.getTargetHost());
<a class="jxr_linenumber" name="145" href="#145">145</a>         Assert.assertEquals(<span class="jxr_string">"wrong local address (r2)"</span>,
<a class="jxr_linenumber" name="146" href="#146">146</a>                      LOCAL61, rt.getLocalAddress());
<a class="jxr_linenumber" name="147" href="#147">147</a>         Assert.assertEquals(<span class="jxr_string">"wrong hop count (r2)"</span>,
<a class="jxr_linenumber" name="148" href="#148">148</a>                      0, rt.getHopCount());
<a class="jxr_linenumber" name="149" href="#149">149</a>         Assert.assertEquals(<span class="jxr_string">"wrong proxy (r2)"</span>,
<a class="jxr_linenumber" name="150" href="#150">150</a>                      <strong class="jxr_keyword">null</strong>, rt.getProxyHost());
<a class="jxr_linenumber" name="151" href="#151">151</a>         Assert.assertEquals(<span class="jxr_string">"wrong route (r2)"</span>,
<a class="jxr_linenumber" name="152" href="#152">152</a>                      <strong class="jxr_keyword">null</strong>, rt.toRoute());
<a class="jxr_linenumber" name="153" href="#153">153</a>         checkCTLS(rt, false, false, false, false);
<a class="jxr_linenumber" name="154" href="#154">154</a> 
<a class="jxr_linenumber" name="155" href="#155">155</a> 
<a class="jxr_linenumber" name="156" href="#156">156</a>         r  = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL42, PROXY3, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="157" href="#157">157</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="158" href="#158">158</a>         Assert.assertEquals(<span class="jxr_string">"wrong target (r3)"</span>,
<a class="jxr_linenumber" name="159" href="#159">159</a>                      TARGET1, rt.getTargetHost());
<a class="jxr_linenumber" name="160" href="#160">160</a>         Assert.assertEquals(<span class="jxr_string">"wrong local address (r3)"</span>,
<a class="jxr_linenumber" name="161" href="#161">161</a>                      LOCAL42, rt.getLocalAddress());
<a class="jxr_linenumber" name="162" href="#162">162</a>         Assert.assertEquals(<span class="jxr_string">"wrong hop count (r3)"</span>,
<a class="jxr_linenumber" name="163" href="#163">163</a>                      0, rt.getHopCount());
<a class="jxr_linenumber" name="164" href="#164">164</a>         Assert.assertEquals(<span class="jxr_string">"wrong proxy (r3)"</span>,
<a class="jxr_linenumber" name="165" href="#165">165</a>                      <strong class="jxr_keyword">null</strong>, rt.getProxyHost());
<a class="jxr_linenumber" name="166" href="#166">166</a>         Assert.assertEquals(<span class="jxr_string">"wrong route (r3)"</span>,
<a class="jxr_linenumber" name="167" href="#167">167</a>                      <strong class="jxr_keyword">null</strong>, rt.toRoute());
<a class="jxr_linenumber" name="168" href="#168">168</a>         checkCTLS(rt, false, false, false, false);
<a class="jxr_linenumber" name="169" href="#169">169</a> 
<a class="jxr_linenumber" name="170" href="#170">170</a> 
<a class="jxr_linenumber" name="171" href="#171">171</a>         rt = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="172" href="#172">172</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="173" href="#173">173</a>             <strong class="jxr_keyword">new</strong> RouteTracker(<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="174" href="#174">174</a>             Assert.fail(<span class="jxr_string">"null route not detected"</span>);
<a class="jxr_linenumber" name="175" href="#175">175</a>         } <strong class="jxr_keyword">catch</strong> (NullPointerException npx) {
<a class="jxr_linenumber" name="176" href="#176">176</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="177" href="#177">177</a>         }
<a class="jxr_linenumber" name="178" href="#178">178</a>     }
<a class="jxr_linenumber" name="179" href="#179">179</a> 
<a class="jxr_linenumber" name="180" href="#180">180</a>     @Test
<a class="jxr_linenumber" name="181" href="#181">181</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testIllegalArgs() {
<a class="jxr_linenumber" name="182" href="#182">182</a> 
<a class="jxr_linenumber" name="183" href="#183">183</a>         RouteTracker rt = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET2, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="184" href="#184">184</a> 
<a class="jxr_linenumber" name="185" href="#185">185</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="186" href="#186">186</a>             rt.connectProxy(<strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="187" href="#187">187</a>             Assert.fail(<span class="jxr_string">"missing proxy argument not detected (connect/false)"</span>);
<a class="jxr_linenumber" name="188" href="#188">188</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="189" href="#189">189</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="190" href="#190">190</a>         }
<a class="jxr_linenumber" name="191" href="#191">191</a> 
<a class="jxr_linenumber" name="192" href="#192">192</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="193" href="#193">193</a>             rt.connectProxy(<strong class="jxr_keyword">null</strong>, false);
<a class="jxr_linenumber" name="194" href="#194">194</a>             Assert.fail(<span class="jxr_string">"missing proxy argument not detected (connect/true)"</span>);
<a class="jxr_linenumber" name="195" href="#195">195</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="196" href="#196">196</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="197" href="#197">197</a>         }
<a class="jxr_linenumber" name="198" href="#198">198</a> 
<a class="jxr_linenumber" name="199" href="#199">199</a>         rt.connectProxy(PROXY1, false);
<a class="jxr_linenumber" name="200" href="#200">200</a> 
<a class="jxr_linenumber" name="201" href="#201">201</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="202" href="#202">202</a>             rt.tunnelProxy(<strong class="jxr_keyword">null</strong>, false);
<a class="jxr_linenumber" name="203" href="#203">203</a>             Assert.fail(<span class="jxr_string">"missing proxy argument not detected (tunnel/false)"</span>);
<a class="jxr_linenumber" name="204" href="#204">204</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="205" href="#205">205</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="206" href="#206">206</a>         }
<a class="jxr_linenumber" name="207" href="#207">207</a> 
<a class="jxr_linenumber" name="208" href="#208">208</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="209" href="#209">209</a>             rt.tunnelProxy(<strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="210" href="#210">210</a>             Assert.fail(<span class="jxr_string">"missing proxy argument not detected (tunnel/true)"</span>);
<a class="jxr_linenumber" name="211" href="#211">211</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="212" href="#212">212</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="213" href="#213">213</a>         }
<a class="jxr_linenumber" name="214" href="#214">214</a> 
<a class="jxr_linenumber" name="215" href="#215">215</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="216" href="#216">216</a>             rt.getHopTarget(-1);
<a class="jxr_linenumber" name="217" href="#217">217</a>             Assert.fail(<span class="jxr_string">"negative hop index not detected"</span>);
<a class="jxr_linenumber" name="218" href="#218">218</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="219" href="#219">219</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="220" href="#220">220</a>         }
<a class="jxr_linenumber" name="221" href="#221">221</a> 
<a class="jxr_linenumber" name="222" href="#222">222</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="223" href="#223">223</a>             rt.getHopTarget(2);
<a class="jxr_linenumber" name="224" href="#224">224</a>             Assert.fail(<span class="jxr_string">"excessive hop index not detected"</span>);
<a class="jxr_linenumber" name="225" href="#225">225</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="226" href="#226">226</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="227" href="#227">227</a>         }
<a class="jxr_linenumber" name="228" href="#228">228</a>     }
<a class="jxr_linenumber" name="229" href="#229">229</a> 
<a class="jxr_linenumber" name="230" href="#230">230</a>     @Test
<a class="jxr_linenumber" name="231" href="#231">231</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testIllegalStates() {
<a class="jxr_linenumber" name="232" href="#232">232</a> 
<a class="jxr_linenumber" name="233" href="#233">233</a>         RouteTracker rt = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="234" href="#234">234</a> 
<a class="jxr_linenumber" name="235" href="#235">235</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="236" href="#236">236</a>             rt.tunnelTarget(false);
<a class="jxr_linenumber" name="237" href="#237">237</a>             Assert.fail(<span class="jxr_string">"unconnectedness not detected (tunnelTarget)"</span>);
<a class="jxr_linenumber" name="238" href="#238">238</a>         } <strong class="jxr_keyword">catch</strong> (IllegalStateException isx) {
<a class="jxr_linenumber" name="239" href="#239">239</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="240" href="#240">240</a>         }
<a class="jxr_linenumber" name="241" href="#241">241</a> 
<a class="jxr_linenumber" name="242" href="#242">242</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="243" href="#243">243</a>             rt.tunnelProxy(PROXY1, false);
<a class="jxr_linenumber" name="244" href="#244">244</a>             Assert.fail(<span class="jxr_string">"unconnectedness not detected (tunnelProxy)"</span>);
<a class="jxr_linenumber" name="245" href="#245">245</a>         } <strong class="jxr_keyword">catch</strong> (IllegalStateException isx) {
<a class="jxr_linenumber" name="246" href="#246">246</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="247" href="#247">247</a>         }
<a class="jxr_linenumber" name="248" href="#248">248</a> 
<a class="jxr_linenumber" name="249" href="#249">249</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="250" href="#250">250</a>             rt.layerProtocol(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="251" href="#251">251</a>             Assert.fail(<span class="jxr_string">"unconnectedness not detected (layerProtocol)"</span>);
<a class="jxr_linenumber" name="252" href="#252">252</a>         } <strong class="jxr_keyword">catch</strong> (IllegalStateException isx) {
<a class="jxr_linenumber" name="253" href="#253">253</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="254" href="#254">254</a>         }
<a class="jxr_linenumber" name="255" href="#255">255</a> 
<a class="jxr_linenumber" name="256" href="#256">256</a> 
<a class="jxr_linenumber" name="257" href="#257">257</a>         <em class="jxr_comment">// connect directly</em>
<a class="jxr_linenumber" name="258" href="#258">258</a>         rt.connectTarget(false);
<a class="jxr_linenumber" name="259" href="#259">259</a> 
<a class="jxr_linenumber" name="260" href="#260">260</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="261" href="#261">261</a>             rt.connectTarget(false);
<a class="jxr_linenumber" name="262" href="#262">262</a>             Assert.fail(<span class="jxr_string">"connectedness not detected (connectTarget)"</span>);
<a class="jxr_linenumber" name="263" href="#263">263</a>         } <strong class="jxr_keyword">catch</strong> (IllegalStateException isx) {
<a class="jxr_linenumber" name="264" href="#264">264</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="265" href="#265">265</a>         }
<a class="jxr_linenumber" name="266" href="#266">266</a> 
<a class="jxr_linenumber" name="267" href="#267">267</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="268" href="#268">268</a>             rt.connectProxy(PROXY2, false);
<a class="jxr_linenumber" name="269" href="#269">269</a>             Assert.fail(<span class="jxr_string">"connectedness not detected (connectProxy)"</span>);
<a class="jxr_linenumber" name="270" href="#270">270</a>         } <strong class="jxr_keyword">catch</strong> (IllegalStateException isx) {
<a class="jxr_linenumber" name="271" href="#271">271</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="272" href="#272">272</a>         }
<a class="jxr_linenumber" name="273" href="#273">273</a> 
<a class="jxr_linenumber" name="274" href="#274">274</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="275" href="#275">275</a>             rt.tunnelTarget(false);
<a class="jxr_linenumber" name="276" href="#276">276</a>             Assert.fail(<span class="jxr_string">"unproxiedness not detected (tunnelTarget)"</span>);
<a class="jxr_linenumber" name="277" href="#277">277</a>         } <strong class="jxr_keyword">catch</strong> (IllegalStateException isx) {
<a class="jxr_linenumber" name="278" href="#278">278</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="279" href="#279">279</a>         }
<a class="jxr_linenumber" name="280" href="#280">280</a> 
<a class="jxr_linenumber" name="281" href="#281">281</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="282" href="#282">282</a>             rt.tunnelProxy(PROXY1, false);
<a class="jxr_linenumber" name="283" href="#283">283</a>             Assert.fail(<span class="jxr_string">"unproxiedness not detected (tunnelProxy)"</span>);
<a class="jxr_linenumber" name="284" href="#284">284</a>         } <strong class="jxr_keyword">catch</strong> (IllegalStateException isx) {
<a class="jxr_linenumber" name="285" href="#285">285</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="286" href="#286">286</a>         }
<a class="jxr_linenumber" name="287" href="#287">287</a>     }
<a class="jxr_linenumber" name="288" href="#288">288</a> 
<a class="jxr_linenumber" name="289" href="#289">289</a>     @Test
<a class="jxr_linenumber" name="290" href="#290">290</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testDirectRoutes() {
<a class="jxr_linenumber" name="291" href="#291">291</a> 
<a class="jxr_linenumber" name="292" href="#292">292</a>         <strong class="jxr_keyword">final</strong> HttpRouteDirector rd = <strong class="jxr_keyword">new</strong> BasicRouteDirector();
<a class="jxr_linenumber" name="293" href="#293">293</a>         HttpRoute r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, false);
<a class="jxr_linenumber" name="294" href="#294">294</a>         RouteTracker rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="295" href="#295">295</a>         <strong class="jxr_keyword">boolean</strong> complete = checkVia(rt, r, rd, 2);
<a class="jxr_linenumber" name="296" href="#296">296</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 1"</span>, complete);
<a class="jxr_linenumber" name="297" href="#297">297</a> 
<a class="jxr_linenumber" name="298" href="#298">298</a>         r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, LOCAL62, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="299" href="#299">299</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="300" href="#300">300</a>         complete = checkVia(rt, r, rd, 2);
<a class="jxr_linenumber" name="301" href="#301">301</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 2"</span>, complete);
<a class="jxr_linenumber" name="302" href="#302">302</a>     }
<a class="jxr_linenumber" name="303" href="#303">303</a> 
<a class="jxr_linenumber" name="304" href="#304">304</a>     @Test
<a class="jxr_linenumber" name="305" href="#305">305</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testProxyRoutes() {
<a class="jxr_linenumber" name="306" href="#306">306</a> 
<a class="jxr_linenumber" name="307" href="#307">307</a>         <strong class="jxr_keyword">final</strong> HttpRouteDirector rd = <strong class="jxr_keyword">new</strong> BasicRouteDirector();
<a class="jxr_linenumber" name="308" href="#308">308</a>         HttpRoute r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, <strong class="jxr_keyword">null</strong>, PROXY1, false);
<a class="jxr_linenumber" name="309" href="#309">309</a>         RouteTracker rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="310" href="#310">310</a>         <strong class="jxr_keyword">boolean</strong> complete = checkVia(rt, r, rd, 2);
<a class="jxr_linenumber" name="311" href="#311">311</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 1"</span>, complete);
<a class="jxr_linenumber" name="312" href="#312">312</a> 
<a class="jxr_linenumber" name="313" href="#313">313</a>         <em class="jxr_comment">// tunnelled, but neither secure nor layered</em>
<a class="jxr_linenumber" name="314" href="#314">314</a>         r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL61, PROXY3, false,
<a class="jxr_linenumber" name="315" href="#315">315</a>                           TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="316" href="#316">316</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="317" href="#317">317</a>         complete = checkVia(rt, r, rd, 3);
<a class="jxr_linenumber" name="318" href="#318">318</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 2"</span>, complete);
<a class="jxr_linenumber" name="319" href="#319">319</a> 
<a class="jxr_linenumber" name="320" href="#320">320</a>         <em class="jxr_comment">// tunnelled, layered, but not secure</em>
<a class="jxr_linenumber" name="321" href="#321">321</a>         r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL61, PROXY3, false,
<a class="jxr_linenumber" name="322" href="#322">322</a>                           TunnelType.TUNNELLED, LayerType.LAYERED);
<a class="jxr_linenumber" name="323" href="#323">323</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="324" href="#324">324</a>         complete = checkVia(rt, r, rd, 4);
<a class="jxr_linenumber" name="325" href="#325">325</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 3"</span>, complete);
<a class="jxr_linenumber" name="326" href="#326">326</a> 
<a class="jxr_linenumber" name="327" href="#327">327</a>         <em class="jxr_comment">// tunnelled, layered, secure</em>
<a class="jxr_linenumber" name="328" href="#328">328</a>         r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL61, PROXY3, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="329" href="#329">329</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="330" href="#330">330</a>         complete = checkVia(rt, r, rd, 4);
<a class="jxr_linenumber" name="331" href="#331">331</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 4"</span>, complete);
<a class="jxr_linenumber" name="332" href="#332">332</a>     }
<a class="jxr_linenumber" name="333" href="#333">333</a> 
<a class="jxr_linenumber" name="334" href="#334">334</a>     @Test
<a class="jxr_linenumber" name="335" href="#335">335</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testProxyChainRoutes() {
<a class="jxr_linenumber" name="336" href="#336">336</a> 
<a class="jxr_linenumber" name="337" href="#337">337</a>         <strong class="jxr_keyword">final</strong> HttpRouteDirector rd = <strong class="jxr_keyword">new</strong> BasicRouteDirector();
<a class="jxr_linenumber" name="338" href="#338">338</a>         HttpHost[] proxies = { PROXY1, PROXY2 };
<a class="jxr_linenumber" name="339" href="#339">339</a>         HttpRoute r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, LOCAL42, proxies, false,
<a class="jxr_linenumber" name="340" href="#340">340</a>                                     TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="341" href="#341">341</a>         RouteTracker rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="342" href="#342">342</a>         <strong class="jxr_keyword">boolean</strong> complete = checkVia(rt, r, rd, 3);
<a class="jxr_linenumber" name="343" href="#343">343</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 1"</span>, complete);
<a class="jxr_linenumber" name="344" href="#344">344</a> 
<a class="jxr_linenumber" name="345" href="#345">345</a>         <em class="jxr_comment">// tunnelled, but neither secure nor layered</em>
<a class="jxr_linenumber" name="346" href="#346">346</a>         proxies = <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY3, PROXY2 };
<a class="jxr_linenumber" name="347" href="#347">347</a>         r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, proxies, false,
<a class="jxr_linenumber" name="348" href="#348">348</a>                           TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="349" href="#349">349</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="350" href="#350">350</a>         complete = checkVia(rt, r, rd, 4);
<a class="jxr_linenumber" name="351" href="#351">351</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 2"</span>, complete);
<a class="jxr_linenumber" name="352" href="#352">352</a> 
<a class="jxr_linenumber" name="353" href="#353">353</a>         <em class="jxr_comment">// tunnelled, layered, but not secure</em>
<a class="jxr_linenumber" name="354" href="#354">354</a>         proxies = <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY3, PROXY2, PROXY1 };
<a class="jxr_linenumber" name="355" href="#355">355</a>         r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, LOCAL61, proxies, false,
<a class="jxr_linenumber" name="356" href="#356">356</a>                           TunnelType.TUNNELLED, LayerType.LAYERED);
<a class="jxr_linenumber" name="357" href="#357">357</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="358" href="#358">358</a>         complete = checkVia(rt, r, rd, 6);
<a class="jxr_linenumber" name="359" href="#359">359</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 3"</span>, complete);
<a class="jxr_linenumber" name="360" href="#360">360</a> 
<a class="jxr_linenumber" name="361" href="#361">361</a>         <em class="jxr_comment">// tunnelled, layered, secure</em>
<a class="jxr_linenumber" name="362" href="#362">362</a>         proxies = <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY1, PROXY3 };
<a class="jxr_linenumber" name="363" href="#363">363</a>         r = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL61, proxies, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="364" href="#364">364</a>                           TunnelType.TUNNELLED, LayerType.LAYERED);
<a class="jxr_linenumber" name="365" href="#365">365</a>         rt = <strong class="jxr_keyword">new</strong> RouteTracker(r);
<a class="jxr_linenumber" name="366" href="#366">366</a>         complete = checkVia(rt, r, rd, 5);
<a class="jxr_linenumber" name="367" href="#367">367</a>         Assert.assertTrue(<span class="jxr_string">"incomplete route 4"</span>, complete);
<a class="jxr_linenumber" name="368" href="#368">368</a>     }
<a class="jxr_linenumber" name="369" href="#369">369</a> 
<a class="jxr_linenumber" name="370" href="#370">370</a>     @Test
<a class="jxr_linenumber" name="371" href="#371">371</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testEqualsHashcodeCloneToString()
<a class="jxr_linenumber" name="372" href="#372">372</a>         <strong class="jxr_keyword">throws</strong> CloneNotSupportedException {
<a class="jxr_linenumber" name="373" href="#373">373</a> 
<a class="jxr_linenumber" name="374" href="#374">374</a>         RouteTracker rt0 = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="375" href="#375">375</a>         RouteTracker rt1 = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET2, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="376" href="#376">376</a>         RouteTracker rt2 = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="377" href="#377">377</a>         RouteTracker rt3 = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="378" href="#378">378</a>         RouteTracker rt4 = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET1, LOCAL41);
<a class="jxr_linenumber" name="379" href="#379">379</a>         RouteTracker rt6 = <strong class="jxr_keyword">new</strong> RouteTracker(TARGET1, LOCAL62);
<a class="jxr_linenumber" name="380" href="#380">380</a> 
<a class="jxr_linenumber" name="381" href="#381">381</a>         Assert.assertFalse(<span class="jxr_string">"rt0"</span>, rt0.equals(<strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="382" href="#382">382</a>         Assert.assertTrue(<span class="jxr_string">"rt0"</span>, rt0.equals(rt0));
<a class="jxr_linenumber" name="383" href="#383">383</a>         Assert.assertFalse(<span class="jxr_string">"rt0"</span>, rt0.equals(rt0.toString()));
<a class="jxr_linenumber" name="384" href="#384">384</a> 
<a class="jxr_linenumber" name="385" href="#385">385</a>         Assert.assertFalse(<span class="jxr_string">"rt0 == rt4"</span>, rt0.equals(rt4));
<a class="jxr_linenumber" name="386" href="#386">386</a>         Assert.assertFalse(<span class="jxr_string">"rt0 == rt1"</span>, rt0.equals(rt1)); <em class="jxr_comment">// Check host takes part in equals</em>
<a class="jxr_linenumber" name="387" href="#387">387</a> 
<a class="jxr_linenumber" name="388" href="#388">388</a>         <em class="jxr_comment">// Check that connection takes part in equals</em>
<a class="jxr_linenumber" name="389" href="#389">389</a>         Assert.assertTrue(<span class="jxr_string">"rt0 != rt2"</span>, rt0.equals(rt2));
<a class="jxr_linenumber" name="390" href="#390">390</a>         rt2.connectTarget(false);
<a class="jxr_linenumber" name="391" href="#391">391</a>         Assert.assertFalse(<span class="jxr_string">"rt0 == rt2"</span>, rt0.equals(rt2));
<a class="jxr_linenumber" name="392" href="#392">392</a> 
<a class="jxr_linenumber" name="393" href="#393">393</a>         Assert.assertTrue(<span class="jxr_string">"rt0 != rt3"</span>, rt0.equals(rt3));
<a class="jxr_linenumber" name="394" href="#394">394</a>         rt3.connectTarget(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="395" href="#395">395</a>         Assert.assertFalse(<span class="jxr_string">"rt0 == rt3"</span>, rt0.equals(rt3));
<a class="jxr_linenumber" name="396" href="#396">396</a>         Assert.assertFalse(<span class="jxr_string">"rt2 == rt3"</span>, rt2.equals(rt3)); <em class="jxr_comment">// Test secure takes part</em>
<a class="jxr_linenumber" name="397" href="#397">397</a> 
<a class="jxr_linenumber" name="398" href="#398">398</a>         <em class="jxr_comment">// TODO needs tests for tunnel and layered</em>
<a class="jxr_linenumber" name="399" href="#399">399</a> 
<a class="jxr_linenumber" name="400" href="#400">400</a>         Assert.assertFalse(<span class="jxr_string">"rt4 == rt0"</span>, rt4.equals(rt0));
<a class="jxr_linenumber" name="401" href="#401">401</a>         Assert.assertFalse(<span class="jxr_string">"rt0 == rt6"</span>, rt0.equals(rt6));
<a class="jxr_linenumber" name="402" href="#402">402</a>         Assert.assertFalse(<span class="jxr_string">"rt6 == rt0"</span>, rt6.equals(rt0));
<a class="jxr_linenumber" name="403" href="#403">403</a>         Assert.assertFalse(<span class="jxr_string">"rt4 == rt6"</span>, rt4.equals(rt6));
<a class="jxr_linenumber" name="404" href="#404">404</a>         Assert.assertFalse(<span class="jxr_string">"rt6 == rt4"</span>, rt6.equals(rt4));
<a class="jxr_linenumber" name="405" href="#405">405</a> 
<a class="jxr_linenumber" name="406" href="#406">406</a>         <em class="jxr_comment">// it is likely but not guaranteed that the hashcodes are different</em>
<a class="jxr_linenumber" name="407" href="#407">407</a>         Assert.assertFalse(<span class="jxr_string">"rt0 == rt4 (hashcode)"</span>, rt0.hashCode() == rt4.hashCode());
<a class="jxr_linenumber" name="408" href="#408">408</a>         Assert.assertFalse(<span class="jxr_string">"rt0 == rt6 (hashcode)"</span>, rt0.hashCode() == rt6.hashCode());
<a class="jxr_linenumber" name="409" href="#409">409</a>         Assert.assertFalse(<span class="jxr_string">"rt6 == rt4 (hashcode)"</span>, rt6.hashCode() == rt4.hashCode());
<a class="jxr_linenumber" name="410" href="#410">410</a> 
<a class="jxr_linenumber" name="411" href="#411">411</a>         Assert.assertEquals(<span class="jxr_string">"rt0 (clone)"</span>, rt0, rt0.clone());
<a class="jxr_linenumber" name="412" href="#412">412</a>         Assert.assertEquals(<span class="jxr_string">"rt4 (clone)"</span>, rt4, rt4.clone());
<a class="jxr_linenumber" name="413" href="#413">413</a>         Assert.assertEquals(<span class="jxr_string">"rt6 (clone)"</span>, rt6, rt6.clone());
<a class="jxr_linenumber" name="414" href="#414">414</a> 
<a class="jxr_linenumber" name="415" href="#415">415</a> 
<a class="jxr_linenumber" name="416" href="#416">416</a>         <em class="jxr_comment">// we collect (clones of) the different tracked routes along the way</em>
<a class="jxr_linenumber" name="417" href="#417">417</a>         <em class="jxr_comment">// rt0 -&gt; direct connection</em>
<a class="jxr_linenumber" name="418" href="#418">418</a>         <em class="jxr_comment">// rt1 -&gt; via single proxy</em>
<a class="jxr_linenumber" name="419" href="#419">419</a>         <em class="jxr_comment">// rt2 -&gt; via proxy chain</em>
<a class="jxr_linenumber" name="420" href="#420">420</a>         Set&lt;RouteTracker&gt; hs = <strong class="jxr_keyword">new</strong> HashSet&lt;RouteTracker&gt;();
<a class="jxr_linenumber" name="421" href="#421">421</a> 
<a class="jxr_linenumber" name="422" href="#422">422</a>         <em class="jxr_comment">// we also collect hashcodes for the different paths</em>
<a class="jxr_linenumber" name="423" href="#423">423</a>         <em class="jxr_comment">// since we can't guarantee what influence the HttpHost hashcodes have,</em>
<a class="jxr_linenumber" name="424" href="#424">424</a>         <em class="jxr_comment">// we keep separate sets here</em>
<a class="jxr_linenumber" name="425" href="#425">425</a>         Set&lt;Integer&gt; hc0 = <strong class="jxr_keyword">new</strong> HashSet&lt;Integer&gt;();
<a class="jxr_linenumber" name="426" href="#426">426</a>         Set&lt;Integer&gt; hc4 = <strong class="jxr_keyword">new</strong> HashSet&lt;Integer&gt;();
<a class="jxr_linenumber" name="427" href="#427">427</a>         Set&lt;Integer&gt; hc6 = <strong class="jxr_keyword">new</strong> HashSet&lt;Integer&gt;();
<a class="jxr_linenumber" name="428" href="#428">428</a> 
<a class="jxr_linenumber" name="429" href="#429">429</a>         RouteTracker rt = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="430" href="#430">430</a> 
<a class="jxr_linenumber" name="431" href="#431">431</a>         Assert.assertTrue(hs.add(rt0));
<a class="jxr_linenumber" name="432" href="#432">432</a>         Assert.assertTrue(hs.add(rt4));
<a class="jxr_linenumber" name="433" href="#433">433</a>         Assert.assertTrue(hs.add(rt6));
<a class="jxr_linenumber" name="434" href="#434">434</a> 
<a class="jxr_linenumber" name="435" href="#435">435</a>         Assert.assertTrue(hc0.add(Integer.valueOf(rt0.hashCode())));
<a class="jxr_linenumber" name="436" href="#436">436</a>         Assert.assertTrue(hc4.add(Integer.valueOf(rt4.hashCode())));
<a class="jxr_linenumber" name="437" href="#437">437</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt6.hashCode())));
<a class="jxr_linenumber" name="438" href="#438">438</a> 
<a class="jxr_linenumber" name="439" href="#439">439</a>         rt = (RouteTracker) rt0.clone();
<a class="jxr_linenumber" name="440" href="#440">440</a>         rt.connectTarget(false);
<a class="jxr_linenumber" name="441" href="#441">441</a>         Assert.assertTrue(hs.add(rt));
<a class="jxr_linenumber" name="442" href="#442">442</a>         Assert.assertTrue(hc0.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="443" href="#443">443</a> 
<a class="jxr_linenumber" name="444" href="#444">444</a>         rt = (RouteTracker) rt0.clone();
<a class="jxr_linenumber" name="445" href="#445">445</a>         rt.connectTarget(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="446" href="#446">446</a>         Assert.assertTrue(hs.add(rt));
<a class="jxr_linenumber" name="447" href="#447">447</a>         Assert.assertTrue(hc0.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="448" href="#448">448</a> 
<a class="jxr_linenumber" name="449" href="#449">449</a> 
<a class="jxr_linenumber" name="450" href="#450">450</a>         <em class="jxr_comment">// proxy (insecure) -&gt; tunnel (insecure) -&gt; layer (secure)</em>
<a class="jxr_linenumber" name="451" href="#451">451</a>         rt = (RouteTracker) rt4.clone();
<a class="jxr_linenumber" name="452" href="#452">452</a>         rt.connectProxy(PROXY1, false);
<a class="jxr_linenumber" name="453" href="#453">453</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="454" href="#454">454</a>         <em class="jxr_comment">// this is not guaranteed to be unique...</em>
<a class="jxr_linenumber" name="455" href="#455">455</a>         Assert.assertTrue(hc4.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="456" href="#456">456</a> 
<a class="jxr_linenumber" name="457" href="#457">457</a>         rt.tunnelTarget(false);
<a class="jxr_linenumber" name="458" href="#458">458</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="459" href="#459">459</a>         Assert.assertTrue(hc4.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="460" href="#460">460</a> 
<a class="jxr_linenumber" name="461" href="#461">461</a>         rt.layerProtocol(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="462" href="#462">462</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="463" href="#463">463</a>         Assert.assertTrue(hc4.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="464" href="#464">464</a> 
<a class="jxr_linenumber" name="465" href="#465">465</a> 
<a class="jxr_linenumber" name="466" href="#466">466</a>         <em class="jxr_comment">// proxy (secure) -&gt; tunnel (secure) -&gt; layer (insecure)</em>
<a class="jxr_linenumber" name="467" href="#467">467</a>         rt = (RouteTracker) rt4.clone();
<a class="jxr_linenumber" name="468" href="#468">468</a>         rt.connectProxy(PROXY1, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="469" href="#469">469</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="470" href="#470">470</a>         <em class="jxr_comment">// this is not guaranteed to be unique...</em>
<a class="jxr_linenumber" name="471" href="#471">471</a>         Assert.assertTrue(hc4.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="472" href="#472">472</a> 
<a class="jxr_linenumber" name="473" href="#473">473</a>         rt.tunnelTarget(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="474" href="#474">474</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="475" href="#475">475</a>         Assert.assertTrue(hc4.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="476" href="#476">476</a> 
<a class="jxr_linenumber" name="477" href="#477">477</a>         rt.layerProtocol(false);
<a class="jxr_linenumber" name="478" href="#478">478</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="479" href="#479">479</a>         Assert.assertTrue(hc4.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="480" href="#480">480</a> 
<a class="jxr_linenumber" name="481" href="#481">481</a> 
<a class="jxr_linenumber" name="482" href="#482">482</a>         <em class="jxr_comment">// PROXY1/i -&gt; PROXY2/i -&gt; tunnel/i -&gt; layer/s</em>
<a class="jxr_linenumber" name="483" href="#483">483</a>         rt = (RouteTracker) rt6.clone();
<a class="jxr_linenumber" name="484" href="#484">484</a>         rt.connectProxy(PROXY1, false);
<a class="jxr_linenumber" name="485" href="#485">485</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="486" href="#486">486</a>         <em class="jxr_comment">// this is not guaranteed to be unique...</em>
<a class="jxr_linenumber" name="487" href="#487">487</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="488" href="#488">488</a> 
<a class="jxr_linenumber" name="489" href="#489">489</a>         rt.tunnelProxy(PROXY2, false);
<a class="jxr_linenumber" name="490" href="#490">490</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="491" href="#491">491</a>         <em class="jxr_comment">// this is not guaranteed to be unique...</em>
<a class="jxr_linenumber" name="492" href="#492">492</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="493" href="#493">493</a> 
<a class="jxr_linenumber" name="494" href="#494">494</a>         rt.tunnelTarget(false);
<a class="jxr_linenumber" name="495" href="#495">495</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="496" href="#496">496</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="497" href="#497">497</a> 
<a class="jxr_linenumber" name="498" href="#498">498</a>         rt.layerProtocol(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="499" href="#499">499</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="500" href="#500">500</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="501" href="#501">501</a> 
<a class="jxr_linenumber" name="502" href="#502">502</a> 
<a class="jxr_linenumber" name="503" href="#503">503</a>         <em class="jxr_comment">// PROXY1/s -&gt; PROXY2/s -&gt; tunnel/s -&gt; layer/i</em>
<a class="jxr_linenumber" name="504" href="#504">504</a>         rt = (RouteTracker) rt6.clone();
<a class="jxr_linenumber" name="505" href="#505">505</a>         rt.connectProxy(PROXY1, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="506" href="#506">506</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="507" href="#507">507</a>         <em class="jxr_comment">// this is not guaranteed to be unique...</em>
<a class="jxr_linenumber" name="508" href="#508">508</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="509" href="#509">509</a> 
<a class="jxr_linenumber" name="510" href="#510">510</a>         rt.tunnelProxy(PROXY2, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="511" href="#511">511</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="512" href="#512">512</a>         <em class="jxr_comment">// this is not guaranteed to be unique...</em>
<a class="jxr_linenumber" name="513" href="#513">513</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="514" href="#514">514</a> 
<a class="jxr_linenumber" name="515" href="#515">515</a>         rt.tunnelTarget(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="516" href="#516">516</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="517" href="#517">517</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="518" href="#518">518</a> 
<a class="jxr_linenumber" name="519" href="#519">519</a>         rt.layerProtocol(false);
<a class="jxr_linenumber" name="520" href="#520">520</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="521" href="#521">521</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="522" href="#522">522</a> 
<a class="jxr_linenumber" name="523" href="#523">523</a> 
<a class="jxr_linenumber" name="524" href="#524">524</a>         <em class="jxr_comment">// PROXY2/i -&gt; PROXY1/i -&gt; tunnel/i -&gt; layer/s</em>
<a class="jxr_linenumber" name="525" href="#525">525</a>         rt = (RouteTracker) rt6.clone();
<a class="jxr_linenumber" name="526" href="#526">526</a>         rt.connectProxy(PROXY2, false);
<a class="jxr_linenumber" name="527" href="#527">527</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="528" href="#528">528</a>         <em class="jxr_comment">// this is not guaranteed to be unique...</em>
<a class="jxr_linenumber" name="529" href="#529">529</a>         Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));
<a class="jxr_linenumber" name="530" href="#530">530</a> 
<a class="jxr_linenumber" name="531" href="#531">531</a>         rt.tunnelProxy(PROXY1, false);
<a class="jxr_linenumber" name="532" href="#532">532</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="533" href="#533">533</a>         <em class="jxr_comment">// proxy chain sequence does not affect hashcode, so duplicate:</em>
<a class="jxr_linenumber" name="534" href="#534">534</a>         <em class="jxr_comment">// Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));</em>
<a class="jxr_linenumber" name="535" href="#535">535</a> 
<a class="jxr_linenumber" name="536" href="#536">536</a>         rt.tunnelTarget(false);
<a class="jxr_linenumber" name="537" href="#537">537</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="538" href="#538">538</a>         <em class="jxr_comment">// proxy chain sequence does not affect hashcode, so duplicate:</em>
<a class="jxr_linenumber" name="539" href="#539">539</a>         <em class="jxr_comment">// Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));</em>
<a class="jxr_linenumber" name="540" href="#540">540</a> 
<a class="jxr_linenumber" name="541" href="#541">541</a>         rt.layerProtocol(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="542" href="#542">542</a>         Assert.assertTrue(hs.add((RouteTracker) rt.clone()));
<a class="jxr_linenumber" name="543" href="#543">543</a>         <em class="jxr_comment">// proxy chain sequence does not affect hashcode, so duplicate:</em>
<a class="jxr_linenumber" name="544" href="#544">544</a>         <em class="jxr_comment">// Assert.assertTrue(hc6.add(Integer.valueOf(rt.hashCode())));</em>
<a class="jxr_linenumber" name="545" href="#545">545</a> 
<a class="jxr_linenumber" name="546" href="#546">546</a> 
<a class="jxr_linenumber" name="547" href="#547">547</a>         <em class="jxr_comment">// check that all toString are OK and different</em>
<a class="jxr_linenumber" name="548" href="#548">548</a>         Set&lt;String&gt; rtstrings = <strong class="jxr_keyword">new</strong> HashSet&lt;String&gt;();
<a class="jxr_linenumber" name="549" href="#549">549</a>         <strong class="jxr_keyword">for</strong> (RouteTracker current: hs) {
<a class="jxr_linenumber" name="550" href="#550">550</a>             <strong class="jxr_keyword">final</strong> String rts = checkToString(current);
<a class="jxr_linenumber" name="551" href="#551">551</a>             Assert.assertTrue(<span class="jxr_string">"duplicate toString: "</span> + rts, rtstrings.add(rts));
<a class="jxr_linenumber" name="552" href="#552">552</a>         }
<a class="jxr_linenumber" name="553" href="#553">553</a>     }
<a class="jxr_linenumber" name="554" href="#554">554</a> 
<a class="jxr_linenumber" name="555" href="#555">555</a> 
<a class="jxr_linenumber" name="556" href="#556">556</a>     <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> Helper to check the status of the four flags. */</em>
<a class="jxr_linenumber" name="557" href="#557">557</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> checkCTLS(RouteTracker rt,
<a class="jxr_linenumber" name="558" href="#558">558</a>                                        <strong class="jxr_keyword">boolean</strong> c, <strong class="jxr_keyword">boolean</strong> t,
<a class="jxr_linenumber" name="559" href="#559">559</a>                                        <strong class="jxr_keyword">boolean</strong> l, <strong class="jxr_keyword">boolean</strong> s) {
<a class="jxr_linenumber" name="560" href="#560">560</a>         String rts = rt.toString();
<a class="jxr_linenumber" name="561" href="#561">561</a>         Assert.assertEquals(<span class="jxr_string">"wrong flag connected: "</span> + rts, c, rt.isConnected());
<a class="jxr_linenumber" name="562" href="#562">562</a>         Assert.assertEquals(<span class="jxr_string">"wrong flag tunnelled: "</span> + rts, t, rt.isTunnelled());
<a class="jxr_linenumber" name="563" href="#563">563</a>         Assert.assertEquals(<span class="jxr_string">"wrong enum tunnelled: "</span> + rts,
<a class="jxr_linenumber" name="564" href="#564">564</a>                      t ? TunnelType.TUNNELLED : TunnelType.PLAIN,
<a class="jxr_linenumber" name="565" href="#565">565</a>                      rt.getTunnelType());
<a class="jxr_linenumber" name="566" href="#566">566</a>         Assert.assertEquals(<span class="jxr_string">"wrong flag layered: "</span>   + rts, l, rt.isLayered());
<a class="jxr_linenumber" name="567" href="#567">567</a>         Assert.assertEquals(<span class="jxr_string">"wrong enum layered: "</span>   + rts,
<a class="jxr_linenumber" name="568" href="#568">568</a>                      l ? LayerType.LAYERED : LayerType.PLAIN,
<a class="jxr_linenumber" name="569" href="#569">569</a>                      rt.getLayerType());
<a class="jxr_linenumber" name="570" href="#570">570</a>         Assert.assertEquals(<span class="jxr_string">"wrong flag secure: "</span>    + rts, s, rt.isSecure());
<a class="jxr_linenumber" name="571" href="#571">571</a>     }
<a class="jxr_linenumber" name="572" href="#572">572</a> 
<a class="jxr_linenumber" name="573" href="#573">573</a> 
<a class="jxr_linenumber" name="574" href="#574">574</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="575" href="#575">575</a> <em class="jxr_javadoccomment">     * Helper to check tracking of a route.</em>
<a class="jxr_linenumber" name="576" href="#576">576</a> <em class="jxr_javadoccomment">     * This uses a {@link HttpRouteDirector} to fake establishing the route,</em>
<a class="jxr_linenumber" name="577" href="#577">577</a> <em class="jxr_javadoccomment">     * checking the intermediate steps.</em>
<a class="jxr_linenumber" name="578" href="#578">578</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="579" href="#579">579</a> <em class="jxr_javadoccomment">     * @param rt        the tracker to check with</em>
<a class="jxr_linenumber" name="580" href="#580">580</a> <em class="jxr_javadoccomment">     * @param r         the route to establish</em>
<a class="jxr_linenumber" name="581" href="#581">581</a> <em class="jxr_javadoccomment">     * @param rd        the director to check with</em>
<a class="jxr_linenumber" name="582" href="#582">582</a> <em class="jxr_javadoccomment">     * @param steps     the step count for this invocation</em>
<a class="jxr_linenumber" name="583" href="#583">583</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="584" href="#584">584</a> <em class="jxr_javadoccomment">     * @return  &lt;code&gt;true&lt;/code&gt; iff the route is complete</em>
<a class="jxr_linenumber" name="585" href="#585">585</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="586" href="#586">586</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> checkVia(RouteTracker rt, HttpRoute r,
<a class="jxr_linenumber" name="587" href="#587">587</a>                                          HttpRouteDirector rd, <strong class="jxr_keyword">int</strong> steps) {
<a class="jxr_linenumber" name="588" href="#588">588</a> 
<a class="jxr_linenumber" name="589" href="#589">589</a>         <strong class="jxr_keyword">final</strong> String msg = r.toString() + <span class="jxr_string">" @ "</span> + rt.toString();
<a class="jxr_linenumber" name="590" href="#590">590</a> 
<a class="jxr_linenumber" name="591" href="#591">591</a>         <strong class="jxr_keyword">boolean</strong> complete = false;
<a class="jxr_linenumber" name="592" href="#592">592</a>         <strong class="jxr_keyword">while</strong> (!complete &amp;&amp; (steps &gt; 0)) {
<a class="jxr_linenumber" name="593" href="#593">593</a> 
<a class="jxr_linenumber" name="594" href="#594">594</a>             <strong class="jxr_keyword">int</strong> action = rd.nextStep(r, rt.toRoute());
<a class="jxr_linenumber" name="595" href="#595">595</a>             <strong class="jxr_keyword">switch</strong> (action) {
<a class="jxr_linenumber" name="596" href="#596">596</a> 
<a class="jxr_linenumber" name="597" href="#597">597</a>             <strong class="jxr_keyword">case</strong> HttpRouteDirector.COMPLETE:
<a class="jxr_linenumber" name="598" href="#598">598</a>                 complete = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="599" href="#599">599</a>                 Assert.assertEquals(r, rt.toRoute());
<a class="jxr_linenumber" name="600" href="#600">600</a>                 <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="601" href="#601">601</a> 
<a class="jxr_linenumber" name="602" href="#602">602</a>             <strong class="jxr_keyword">case</strong> HttpRouteDirector.CONNECT_TARGET: {
<a class="jxr_linenumber" name="603" href="#603">603</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> sec = r.isSecure();
<a class="jxr_linenumber" name="604" href="#604">604</a>                 rt.connectTarget(sec);
<a class="jxr_linenumber" name="605" href="#605">605</a>                 checkCTLS(rt, <strong class="jxr_keyword">true</strong>, false, false, sec);
<a class="jxr_linenumber" name="606" href="#606">606</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop count "</span>+msg,
<a class="jxr_linenumber" name="607" href="#607">607</a>                              1, rt.getHopCount());
<a class="jxr_linenumber" name="608" href="#608">608</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop0 "</span>+msg,
<a class="jxr_linenumber" name="609" href="#609">609</a>                              r.getTargetHost(), rt.getHopTarget(0));
<a class="jxr_linenumber" name="610" href="#610">610</a>             } <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="611" href="#611">611</a> 
<a class="jxr_linenumber" name="612" href="#612">612</a>             <strong class="jxr_keyword">case</strong> HttpRouteDirector.CONNECT_PROXY: {
<a class="jxr_linenumber" name="613" href="#613">613</a>                 <em class="jxr_comment">// we assume an insecure proxy connection</em>
<a class="jxr_linenumber" name="614" href="#614">614</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> sec = false;
<a class="jxr_linenumber" name="615" href="#615">615</a>                 rt.connectProxy(r.getProxyHost(), sec);
<a class="jxr_linenumber" name="616" href="#616">616</a>                 checkCTLS(rt, <strong class="jxr_keyword">true</strong>, false, false, sec);
<a class="jxr_linenumber" name="617" href="#617">617</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop count "</span>+msg,
<a class="jxr_linenumber" name="618" href="#618">618</a>                              2, rt.getHopCount());
<a class="jxr_linenumber" name="619" href="#619">619</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop0 "</span>+msg,
<a class="jxr_linenumber" name="620" href="#620">620</a>                              r.getProxyHost(), rt.getHopTarget(0));
<a class="jxr_linenumber" name="621" href="#621">621</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop1 "</span>+msg,
<a class="jxr_linenumber" name="622" href="#622">622</a>                              r.getTargetHost(), rt.getHopTarget(1));
<a class="jxr_linenumber" name="623" href="#623">623</a>             } <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="624" href="#624">624</a> 
<a class="jxr_linenumber" name="625" href="#625">625</a>             <strong class="jxr_keyword">case</strong> HttpRouteDirector.TUNNEL_TARGET: {
<a class="jxr_linenumber" name="626" href="#626">626</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> hops = rt.getHopCount();
<a class="jxr_linenumber" name="627" href="#627">627</a>                 <em class="jxr_comment">// we assume an insecure tunnel</em>
<a class="jxr_linenumber" name="628" href="#628">628</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> sec = false;
<a class="jxr_linenumber" name="629" href="#629">629</a>                 rt.tunnelTarget(sec);
<a class="jxr_linenumber" name="630" href="#630">630</a>                 checkCTLS(rt, <strong class="jxr_keyword">true</strong>, <strong class="jxr_keyword">true</strong>, false, sec);
<a class="jxr_linenumber" name="631" href="#631">631</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop count "</span>+msg,
<a class="jxr_linenumber" name="632" href="#632">632</a>                              hops, rt.getHopCount());
<a class="jxr_linenumber" name="633" href="#633">633</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop0 "</span>+msg,
<a class="jxr_linenumber" name="634" href="#634">634</a>                              r.getProxyHost(), rt.getHopTarget(0));
<a class="jxr_linenumber" name="635" href="#635">635</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hopN "</span>+msg,
<a class="jxr_linenumber" name="636" href="#636">636</a>                              r.getTargetHost(), rt.getHopTarget(hops-1));
<a class="jxr_linenumber" name="637" href="#637">637</a>             } <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="638" href="#638">638</a> 
<a class="jxr_linenumber" name="639" href="#639">639</a>             <strong class="jxr_keyword">case</strong> HttpRouteDirector.TUNNEL_PROXY: {
<a class="jxr_linenumber" name="640" href="#640">640</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> hops = rt.getHopCount(); <em class="jxr_comment">// before tunnelling</em>
<a class="jxr_linenumber" name="641" href="#641">641</a>                 <em class="jxr_comment">// we assume an insecure tunnel</em>
<a class="jxr_linenumber" name="642" href="#642">642</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong>  sec = false;
<a class="jxr_linenumber" name="643" href="#643">643</a>                 <strong class="jxr_keyword">final</strong> HttpHost pxy = r.getHopTarget(hops-1);
<a class="jxr_linenumber" name="644" href="#644">644</a>                 rt.tunnelProxy(pxy, sec);
<a class="jxr_linenumber" name="645" href="#645">645</a>                 <em class="jxr_comment">// Since we're tunnelling to a proxy and not the target,</em>
<a class="jxr_linenumber" name="646" href="#646">646</a>                 <em class="jxr_comment">// the 'tunelling' flag is false: no end-to-end tunnel.</em>
<a class="jxr_linenumber" name="647" href="#647">647</a>                 checkCTLS(rt, <strong class="jxr_keyword">true</strong>, false, false, sec);
<a class="jxr_linenumber" name="648" href="#648">648</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop count "</span>+msg,
<a class="jxr_linenumber" name="649" href="#649">649</a>                              hops+1, rt.getHopCount());
<a class="jxr_linenumber" name="650" href="#650">650</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop0 "</span>+msg,
<a class="jxr_linenumber" name="651" href="#651">651</a>                              r.getProxyHost(), rt.getHopTarget(0));
<a class="jxr_linenumber" name="652" href="#652">652</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop"</span>+hops+<span class="jxr_string">" "</span>+msg,
<a class="jxr_linenumber" name="653" href="#653">653</a>                              pxy, rt.getHopTarget(hops-1));
<a class="jxr_linenumber" name="654" href="#654">654</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hopN "</span>+msg,
<a class="jxr_linenumber" name="655" href="#655">655</a>                              r.getTargetHost(), rt.getHopTarget(hops));
<a class="jxr_linenumber" name="656" href="#656">656</a>             } <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="657" href="#657">657</a> 
<a class="jxr_linenumber" name="658" href="#658">658</a>             <strong class="jxr_keyword">case</strong> HttpRouteDirector.LAYER_PROTOCOL: {
<a class="jxr_linenumber" name="659" href="#659">659</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong>    hops = rt.getHopCount();
<a class="jxr_linenumber" name="660" href="#660">660</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> tun = rt.isTunnelled();
<a class="jxr_linenumber" name="661" href="#661">661</a>                 <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> sec = r.isSecure();
<a class="jxr_linenumber" name="662" href="#662">662</a>                 rt.layerProtocol(sec);
<a class="jxr_linenumber" name="663" href="#663">663</a>                 checkCTLS(rt, <strong class="jxr_keyword">true</strong>, tun, <strong class="jxr_keyword">true</strong>, sec);
<a class="jxr_linenumber" name="664" href="#664">664</a>                 Assert.assertEquals(<span class="jxr_string">"wrong hop count "</span>+msg,
<a class="jxr_linenumber" name="665" href="#665">665</a>                              hops, rt.getHopCount());
<a class="jxr_linenumber" name="666" href="#666">666</a>                 Assert.assertEquals(<span class="jxr_string">"wrong proxy "</span>+msg,
<a class="jxr_linenumber" name="667" href="#667">667</a>                              r.getProxyHost(), rt.getProxyHost());
<a class="jxr_linenumber" name="668" href="#668">668</a>                 Assert.assertEquals(<span class="jxr_string">"wrong target "</span>+msg,
<a class="jxr_linenumber" name="669" href="#669">669</a>                              r.getTargetHost(), rt.getTargetHost());
<a class="jxr_linenumber" name="670" href="#670">670</a>             } <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="671" href="#671">671</a> 
<a class="jxr_linenumber" name="672" href="#672">672</a> 
<a class="jxr_linenumber" name="673" href="#673">673</a>             <em class="jxr_comment">// UNREACHABLE</em>
<a class="jxr_linenumber" name="674" href="#674">674</a>             <strong class="jxr_keyword">default</strong>:
<a class="jxr_linenumber" name="675" href="#675">675</a>                 Assert.fail(<span class="jxr_string">"unexpected action "</span> + action + <span class="jxr_string">" from director, "</span>+msg);
<a class="jxr_linenumber" name="676" href="#676">676</a>                 <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="677" href="#677">677</a> 
<a class="jxr_linenumber" name="678" href="#678">678</a>             } <em class="jxr_comment">// switch</em>
<a class="jxr_linenumber" name="679" href="#679">679</a>             steps--;
<a class="jxr_linenumber" name="680" href="#680">680</a>         }
<a class="jxr_linenumber" name="681" href="#681">681</a> 
<a class="jxr_linenumber" name="682" href="#682">682</a>         <strong class="jxr_keyword">return</strong> complete;
<a class="jxr_linenumber" name="683" href="#683">683</a>     } <em class="jxr_comment">// checkVia</em>
<a class="jxr_linenumber" name="684" href="#684">684</a> 
<a class="jxr_linenumber" name="685" href="#685">685</a> 
<a class="jxr_linenumber" name="686" href="#686">686</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="687" href="#687">687</a> <em class="jxr_javadoccomment">     * Checks the output of &lt;code&gt;toString&lt;/code&gt;.</em>
<a class="jxr_linenumber" name="688" href="#688">688</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="689" href="#689">689</a> <em class="jxr_javadoccomment">     * @param rt        the tracker for which to check the output</em>
<a class="jxr_linenumber" name="690" href="#690">690</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="691" href="#691">691</a> <em class="jxr_javadoccomment">     * @return  the result of &lt;code&gt;rt.toString()&lt;/code&gt;</em>
<a class="jxr_linenumber" name="692" href="#692">692</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="693" href="#693">693</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> String checkToString(RouteTracker rt) {
<a class="jxr_linenumber" name="694" href="#694">694</a>         <strong class="jxr_keyword">if</strong> (rt == <strong class="jxr_keyword">null</strong>)
<a class="jxr_linenumber" name="695" href="#695">695</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="696" href="#696">696</a> 
<a class="jxr_linenumber" name="697" href="#697">697</a>         <strong class="jxr_keyword">final</strong> String rts = rt.toString();
<a class="jxr_linenumber" name="698" href="#698">698</a> 
<a class="jxr_linenumber" name="699" href="#699">699</a>         <strong class="jxr_keyword">if</strong> (rt.getLocalAddress() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="700" href="#700">700</a>             <strong class="jxr_keyword">final</strong> String las = rt.getLocalAddress().toString();
<a class="jxr_linenumber" name="701" href="#701">701</a>             Assert.assertFalse(<span class="jxr_string">"no local address in toString(): "</span> + rts,
<a class="jxr_linenumber" name="702" href="#702">702</a>                         rts.indexOf(las) &lt; 0);
<a class="jxr_linenumber" name="703" href="#703">703</a>         }
<a class="jxr_linenumber" name="704" href="#704">704</a> 
<a class="jxr_linenumber" name="705" href="#705">705</a>         <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i=0; i&lt;rt.getHopCount(); i++) {
<a class="jxr_linenumber" name="706" href="#706">706</a>             <strong class="jxr_keyword">final</strong> String hts = rt.getHopTarget(i).toString();
<a class="jxr_linenumber" name="707" href="#707">707</a>             Assert.assertFalse(<span class="jxr_string">"hop "</span>+i+<span class="jxr_string">" ("</span>+hts+<span class="jxr_string">") missing in toString(): "</span> + rts,
<a class="jxr_linenumber" name="708" href="#708">708</a>                         rts.indexOf(hts) &lt; 0);
<a class="jxr_linenumber" name="709" href="#709">709</a>         }
<a class="jxr_linenumber" name="710" href="#710">710</a> 
<a class="jxr_linenumber" name="711" href="#711">711</a>         <strong class="jxr_keyword">return</strong> rts;
<a class="jxr_linenumber" name="712" href="#712">712</a>     }
<a class="jxr_linenumber" name="713" href="#713">713</a> 
<a class="jxr_linenumber" name="714" href="#714">714</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

